# This spec file is a part of Ghost-kernel project 
# used by the Marionnet project <http://www.marionnet.org>

# Copyright (C) 2009  Jonathan Roudiere
# Licence GPLv2 : GNU GPL version 2

Name:			ghost-kernel
Version:		2.0
Release:		#_SVS_#
Summary:		Linux Ghost Kernel patch and ghost2 utility 
Group:			System Environment/Base
License:		GPLv2
URL:			http://www.marionnet.org/
Vendor:			Marionnet repository
Packager:		Roudiere Jonathan <roudiere@lipn.univ-paris13.fr>
Source0:		ghost-kernel-%{version}.tar.bz2
BuildRoot:		%{_tmppath}/ghost-kernel-%{version}-%{release}-root-%(%{__id_u} ldArch-n)
%description
Linux Ghost Kernel path for #_VS_# version and Ghost2 utility

# to overide architecture detection by rpmbuild 
# BuildArch:		i386

# tags used to add a explicit binary prerequisite, use with 
# a binary name or through a "%define mybin /path/to/mybin"
# a the top and here "BuildPrereq %{mybin}" 
BuildPrereq: 		wget, bash, bzip2, tar, gzip, findutils, perl

# List of packages need to be installed to build 
# package of this software
BuildRequires:		binutils, gcc, make, patch, vde, kernel-utils, ncurses, libpcap
# List of packages need to run software 
Requires:			glibc
BuildConflicts: 	rhbuildsys(DiskFree) < 500Mb

%package -n marionnet-kernel-#_VS_#
Summary: UML kernel binary patched to support ghostification
Group: System Environment/Base
%description -n marionnet-kernel-#_VS_#
The marionnet-kernel package contain the Linux kernel built
for the user-mode-linux (UML) architecture and patched for 
support ghostification.
.
Ghostification allow to hide one or several network interfaces
at the kernel level. When a network interface is ghostified you
could not get informations about this interface (config, stats,
etc ...) and you cann't filter or analyse network packets which
pass through this interface.
.
Ghostification is used by Marionnet to hide some communications
from virtual machines to the host which run marionnet. When a
virtual machine of the marionnet network use a Desktop environment
or launch a GUI application though marionnet, an network interface
is specially use for that and this patch is used in order to don't
disturb marionnet users (especially student) with this type of noise.

%package -n uml-kernel-#_VS_#-ghost
Summary: UML kernel binary patched for support ghostification
Group: System Environment/Base
%description -n uml-kernel-#_VS_#-ghost
The uml-kernel-2.6.X-ghost package contain the Linux kernel built
for the user-mode-linux (UML) architecture and patched for support
ghostification.
.
Ghostification allow to hide one or several network interfaces at
the kernel level. When a network interface is ghostified you could
not get informations about this interface (config, stats, etc ...)
and you can not filter or analyse network packets which pass through
this interface.

%package -n ghost2
Summary: Utility to ghostify and unghostify network interface
Group: System Environment/Base
%description -n ghost2
Ghost2 is a little tool which allow to ghostify a network interface (card).
Ghostify and unghostify operations allow respectively to hide and to make
again visible a network  interface (card). To work successfully ghost2 must
be execute on a Linux Kernel which supports this type of operations. Patch
to the Linux kernels are available at <http://www.marionnet.org/> under the
downloads section.

%prep
%setup -q

%build
make KERNEL_VERSION=#_VS_# apply-patch
make -j 2 pack-kernel-uml KERNEL_VERSION=#_VS_#
make -j 2 pack-kernel-marionnet KERNEL_VERSION=#_VS_#
make pack-ghost2


%install
rm -rf $RPM_BUILD_ROOT
make install-ghost2 DESTDIR=$RPM_BUILD_ROOT
make install-kernel-uml KERNEL_VERSION=#_VS_# DESTDIR=$RPM_BUILD_ROOT
make install-kernel-marionnet KERNEL_VERSION=#_VS_# DESTDIR=$RPM_BUILD_ROOT

%clean
make dist-clean
[ $RPM_BUILD_ROOT != "/" ] && rm -rf $RPM_BUILD_ROOT

%files -n marionnet-kernel-#_VS_#
%defattr(-,root,root,-)
%doc /usr/share/doc/marionnet-kernel-#_VS_#/ghost_kernel_errors.txt
%doc /usr/share/doc/marionnet-kernel-#_VS_#/ghost_kernel_errors.fr.txt
%doc /usr/share/doc/marionnet-kernel-#_VS_#/config-#_VS_#-ghost
%doc /usr/share/doc/marionnet-kernel-#_VS_#/README
%doc /usr/share/doc/marionnet-kernel-#_VS_#/README.Ghostification
%doc /usr/share/doc/marionnet-kernel-#_VS_#/LICENCE
/usr/share/marionnet/kernels/config-#_VS_#-ghost
/usr/share/marionnet/kernels/linux-marionnet-ghost-#_VS_#

%files -n uml-kernel-#_VS_#-ghost
%defattr(-,root,root,-)
/usr/bin/linux-ghost-#_VS_#.uml
%doc /usr/share/doc/uml-kernel-#_VS_#-ghost/ghost_kernel_errors.txt
%doc /usr/share/doc/uml-kernel-#_VS_#-ghost/ghost_kernel_errors.fr.txt
%doc /usr/share/doc/uml-kernel-#_VS_#-ghost/config-#_VS_#-ghost
%doc /usr/share/doc/uml-kernel-#_VS_#-ghost/README
%doc /usr/share/doc/uml-kernel-#_VS_#-ghost/README.Ghostification
%doc /usr/share/doc/uml-kernel-#_VS_#-ghost/LICENCE

%files -n ghost2
%defattr(-,root,root,-)
/usr/sbin/ghost2
/usr/sbin/ghostify
/usr/sbin/unghostify
%doc /usr/share/doc/ghost2/GhostKernelError.fr.txt
%doc /usr/share/doc/ghost2/GhostKernelError.txt
%doc /usr/share/doc/ghost2/LICENCE
%doc /usr/share/doc/ghost2/README
/usr/share/man/fr/man8/ghost2.8.gz
/usr/share/man/fr/man8/ghostify.8.gz
/usr/share/man/fr/man8/unghostify.8.gz
/usr/share/man/man8/ghost2.8.gz
/usr/share/man/man8/ghostify.8.gz
/usr/share/man/man8/unghostify.8.gz

%changelog
* Mon Oct 26 2009 Jonathan Roudiere <roudiere@lipn.univ-paris13.fr> - 2.0.#_SVS_#
- Build at home of the Ghost-Kernel-2.0 for the Marionnet project.

